
def load_clusters(filename):

	f = open(filename)
	clusters = {}

	f.readline()

	for row in f:
		data = row.split()
		if not data[0] in clusters:
			clusters[data[0]] = []
		clusters[data[0]].append(data[2])

	f.close()
	return clusters

def get_rbps_mrnas(regulators):
	rbps = []
	mrnas = []

	for reg in regulators:
		if reg.startswith("hsa"):
			mrnas.append(reg)
		else:
			rbps.append(reg)

	return rbps, mrnas

def num_families(regulators):

	families = set()

	for reg in regulators:
		families.add(reg[:-1])

	return len(families)


def print_cluster_stats(clusters):

	clust_list = [(len(regs), cid, regs) for (cid, regs) in clusters.items()]
	clust_list.sort()
	clust_list.reverse()

	print("clustid\tnumreg\tnumrpb\tnummrna")
	for (l, cid, regs) in clust_list:
		rbps, mrnas = get_rbps_mrnas(regs) 
		rbpfamilies = num_families(rbps)
		mrnafamilies = num_families(mrnas)
		print("%s\t%d\t%d(%d)\t%d(%d)" %(cid, l, len(rbps), rbpfamilies, len(mrnas), mrnafamilies))



filename = input("Inserire nome file: ")

clusters = load_clusters(filename)
print_cluster_stats(clusters)