def load_alignments(filename):
    f = open(filename)

    aligns = []

    for row in f:
        if row[0] == '#':
            continue
        data = row.split()
        aligns.append(data[1])

    f.close()
    return aligns

def alignments2consensus(aligns):
    consensus = ""
    for pos in range(len(aligns[0])):
        profile = [align[pos] for align in aligns]
        counts = compute_counts(profile)
        mostfreq = most_frequent(counts)
        if mostfreq not in ".-":
            consensus += mostfreq
    return consensus


def compute_counts(l):
    counts = {}
    for el in l:
        if not el in counts:
            counts[el] = 1
        else:
            counts[el] += 1
    return counts  

def most_frequent(counts):
    l = [(v,k) for (k,v) in counts.items()]
    l.sort(reverse=True)
    return l[0][1]

filename = input("Inserire nome file: ")

alignments = load_alignments(filename)
print(alignments2consensus(alignments))